

/** 	Agente che accede a file testo ubicati ovunque;il file viene
		specificato  nella chiamata all'agente stesso
		e dopo operazione di filtraggio vengono scritti in un altro file
		(se non esiste viene creato).Le istruzioni per il filtraggio
		e il nome del file destinazione vengono prelevate da un file testo
		il cui nome :"Istruzioni.txt".Il file deve contenere al max 2
		comandi disposti su due righe.
		Se il file di istruzioni  vuoto si usano le istruzioni di default:
		nome file :"StampaFileDiTesto.txt";carattere da :"a".
		@author     Ialacci Massimiliano
	    @version    1.02
	    @language   jdk 1.2.2
 */

import java.io.*;
import java.util.*;
import java.lang.reflect.*;

import SOMA.agent.*;
import SOMA.massimiliano.*;

public class Lettore2 extends Agent
{
	String direttorio;
	String istRiga = "";		//serve per contenere le linee del file di istruzioni
	String risultato ="";		//serve per contenere le linee del file da filtrare
	String fileC;  				//file con estensione
	String file;
	String fileIst = "Istruzioni.txt"; // file contenente le istruzioni per l'Agente
	String carattere ;			//carattere da cercare
	String fileDestinazione ;	//file di destinazione
	int numComandi;
	BufferedReader in;
		// true = argomenti inseriti in numero corretto
	boolean argomenti = true;
		// serve per contenere il file da filtrare
	Vector contenitore = new Vector();
		// serve per contenere il file filtrato
	Vector contFiltrato = new Vector();
		// serve per contenere le istruzioni per l'Agente
	Vector istruzioni = new Vector();


	public void putArgument ( Object obj)
	{
		String[] nome = (String[])obj;
		if(nome.length < 3)
		{
			if(nome.length == 2)
			{
				direttorio = nome[0];
				file = nome[1];
			}
			if(nome.length == 1)
			{
				direttorio = System.getProperty("user.dir");
				file = nome[0];
			}
			if(nome.length < 1)
			{
				direttorio = System.getProperty("user.dir");
				file = "fileDiProva.txt";
			}
		}
		else
		{
			argomenti = false;
		}

	}


	public void run()
	{

		PrintStream out = agentSystem.getOut();
		if(argomenti)
		{

			fileC = componi();
			out.println(fileC + " questo  il file da cercare");

			/**	il codice seguente mi permette di accedere al file di testo
				specificato e leggerlo per linee. Il codice  racchiuso in
				un blocco try catch perch la BufferedReader pu lanciare una
				eccezione se non riesce ad effettuare la lettura.
			*/
			try
			{
				in = new BufferedReader(new FileReader(fileC));
				while((risultato=in.readLine())!=null)
				contenitore.addElement(risultato);
				/** //per debug contenitore
				int numDebug = contenitore.size();
				for(int i = 0 ; i < numDebug ; i++)
				{
					out.println((String)contenitore.get(i));
				}//fine debug contenitore (OK) */

				/**queste 2 righe erano utilizzate nella prima
				   versione (senza filtro) */
				//risultato = in.readLine();
				//out.println("questo  il risultato: "+risultato);
				in.close();
			}
			catch(Exception e)
			{
				out.println("non  stato trovato il file da filtrare");
			}//fine lettura file

			/**	il codice seguente serve per istruire l' Agente tramite
				lettura di un file txt.Il file deve contenere al max 2 comandi
				disposti su due righe.Prima riga file, seconda carattere,
				se c' una sola riga  il carattere.
			*/
			try
			{
				in = new BufferedReader(new FileReader(fileIst));
				while((istRiga = in.readLine()) != null)
				istruzioni.addElement(istRiga);
				in.close();
			}
			catch(Exception e)
			{
				out.println("non  stato trovato il file dei comandi");
			}//fine lettura file

			numComandi = istruzioni.size();
			if((numComandi < 3)&&(numComandi > 0))
			{
				if( numComandi == 2 )
				{
					fileDestinazione = (String)istruzioni.get(0);
					carattere = (String)istruzioni.get(1);

				}
				else
				{
					fileDestinazione = "StampaFileDiProva.txt";
					carattere = (String)istruzioni.get(0);
				}
			}
			else
			{
				out.println("il file istruzioni.txt  vuoto");
				out.println("percui si useranno le istruzioni");
				out.println("di DEFAULT : fileDestinazione = ");
				out.println("StampaFileDiProva.txt e carattere = a");
				fileDestinazione = "StampaFileDiProva.txt";
				carattere = "a";
			}


			CreateFileText cft = new CreateFileText(fileDestinazione);
			cft.createFile(out);

			//creatoreFile();//crea il file qualora non esiste

			Filtro2 filtro = new Filtro2(contenitore,carattere);
			//filtro.filtroTesto();// lo usato per il debug della classe Filtro1
			contFiltrato = filtro.filtroTesto(out);

			CreateFileText salva = new CreateFileText(fileDestinazione,contFiltrato);
			salva.save(out);

			//salvataggio();

			//out.println(filtro.filtroTesto());//inserito per il debug della classe filtro




			/** questo blocco try catch serviva per scrivere sul
				file nella prima versione (senza filtro)

			try
			{
				String prova = "ermenegildo";
				PrintWriter fuori
   				= new PrintWriter(new FileWriter("StampaFileDiProva.txt"));
				fuori.println(prova);
				fuori.println("va a fare la spesa");
				fuori.println(risultato);
				fuori.close();   //  importantissimo perch altrimenti non  detto
								 // che il buffer di uscita venga svuotato,questo
								 // implica che possono essere persi i dati
			}
			catch(Exception e)
			{
				out.println("non  andata a buon fine la scrittura");
			}*/
		}
		else
		{
			out.println("inserire da zero a due argomenti");
		}
	}


	//fornisce il file da cercare
	public String componi()
	{
		return direttorio+File.separator+file;
	}


	//metodo per la creazione dei file
	/**public void creatoreFile()
	{
		PrintStream out = agentSystem.getOut();
		File fileDiStampa = new File("StampaFileDiProva.txt");
		if(!fileDiStampa.exists())
		{
			try
			{
				if(fileDiStampa.createNewFile())
				{
					out.println("la creazione  andata a buon fine");
				}
			}
			catch(Exception ex)
			{
				out.println("non crea il file desiderato");
			}
		}
		else
		{
			out.println("file gi esistente");
		}

	}// fine creatoreFile
	*/


	//metodo di filtraggio
	/**public void filtro()
	{
		PrintStream out = agentSystem.getOut();
		int numElementi = contenitore.size();
		for(int i = 0 ; i < numElementi ; i++)
		{
			String contenitoreRighe = (String)contenitore.get(i);
			//out.println(contenitoreRighe+" questa  la riga n. "+i);
			if(contenitoreRighe.substring(0,1).equals("a"))
			{
				contFiltrato.addElement(contenitoreRighe);
			}

		}
		//per debug contenitore
		int numDebug = contFiltrato.size();
		for(int i = 0 ; i < numDebug ; i++)
		{
			out.println((String)contFiltrato.get(i)+"   ...contenitore filtrato");
		}
	}//fine filtro
	*/

	/**public void salvataggio()
	{
		PrintStream out = agentSystem.getOut();
		String linea;
		int numRighe = contFiltrato.size();//numero degli elementi (righe) di contFiltrato
		try
		{
			PrintWriter scrittore =
				new PrintWriter(new FileWriter("StampaFileDiProva.txt"));
			for(int i = 0 ; i < numRighe ; i++)
			{
				linea = (String)contFiltrato.get(i);
				scrittore.println(linea);
			}
			scrittore.close();
		}
		catch(Exception e)
		{
			out.println("la scrittura non  andata a buon fine");
		}
	}
	*/




}

