package MobileMonitoring;

import java.io.*;
import java.util.*;
import com.adventnet.snmp.snmp2.*;

//Questa e' una classe che racchiude la informazioni relative ad un utente USM
//ho preferito utilizzare questa piuttosto che la USMUserEntry per evitare di
//appesantire l'agente con info. replicate visto che, ad es., il nome dell'utente e' sempre lo stesso
//anche il nome dell'host non serve perche' sara' sempre quello del nodo su cui di volta
//in volta viene a trovarsi l'agente mobile

public class infoUser implements Serializable
{
	byte[] principal;
    int authProto = -1;
    int privProto = -1;
    byte[] authPwd = null;
    byte[] privPwd = null;
	byte[] engineID = null;


   public infoUser(USMUserEntry user)
   {
   		if (user.getSecurityLevel()== Snmp3Message.NO_AUTH_NO_PRIV)
   		{
   			principal = user.getUserName();
   			engineID = user.getEngineID();
       		authProto = USMUserEntry.NO_AUTH;
       	}
   		if (user.getSecurityLevel()== Snmp3Message.AUTH_NO_PRIV)
   		{
   			authProto = user.getAuthProtocol();
        	authPwd = user.getAuthPassword();
   		}
   		if (user.getSecurityLevel()== Snmp3Message.AUTH_PRIV)
   		{
   			privProto = user.getPrivProtocol();
        	privPwd = user.getPrivPassword();
        }
   }

   public infoUser(byte[] username,byte[] rem_engine)
   {
   		principal = username;
   		engineID = rem_engine;
        authProto = USMUserEntry.NO_AUTH;
   }

   public infoUser(byte[] username,byte[] rem_engine,int AProto, String APwd)
   {
        this(username,rem_engine);
		authProto = AProto;
       	authPwd = APwd.getBytes();
   }

   public infoUser(byte[] username,byte[] rem_engine,int AProto, String APwd, int PProto, String PPwd)
   {
        this(username,rem_engine,AProto, APwd);
        privProto = PProto;
        privPwd = PPwd.getBytes();
   }

	public byte[] getEngine()
	{
		return engineID;
	}

	public byte[] getPrincipal()
	{
		return principal;
	}

   public byte[] getAuthPwd()
   {
        return authPwd;
   }

   public byte[] getPrivPwd()
   {
        return privPwd;
   }

   public int getAuthProtocol()
   {
        return authProto;
   }

   public int getPrivProtocol()
   {
        return privProto;
   }

}