package MonitorConfig;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.io.*;

public class IpAddress implements Serializable
{
    InetAddress Addr;
    int Port;

    public IpAddress()
    {
        Port = 161;
        try
        {
            Addr = InetAddress.getLocalHost();
        }
        catch(UnknownHostException ex) {}
    }

    public IpAddress(int pt)
    {
        Port = pt;
        try
        {
            Addr = InetAddress.getLocalHost();
        }
        catch(UnknownHostException ex) {}
    }

    //forma 127.0.0.1:161
    public IpAddress(String ad)
    {
        Port = 161;
        int i = ad.indexOf(58);
        String ad1;
        String ad2;
        if(i < 0)
        {
            ad1 = ad;
            ad2 = "161";
        }
        else
        {
            ad1 = ad.substring(0, i);
            ad2 = ad.substring(i + 1, ad.length());
        }
        i = ad1.indexOf(47);
        if(i >= 0)
            ad1 = ad.substring(0, i);
        Port = new Integer(ad2).intValue();
        try
        {
            Addr = InetAddress.getByName(ad1);
        }
        catch(UnknownHostException ex) {}
    }

    public IpAddress(String ad, int pt)
    {
        Port = pt;
        Port %= 0x10000;
        try
        {
            Addr = InetAddress.getByName(ad);
        }
        catch(UnknownHostException ex) {}
    }

    public IpAddress(InetAddress ad)
    {
        Addr = ad;
        Port = 161;
    }

    public IpAddress(InetAddress ad, int pt)
    {
        Addr = ad;
        Port = pt;
        Port %= 0x10000;
    }

    public String toString()
    {
        if(Addr == null)
        {
            return "0.0.0.0";
        }
        else
        {
            String ad = Addr.getHostAddress();
            return ad + ":" + Port;
        }
    }

    public InetAddress getAddr()
    {
        return Addr;
    }

    public int getPort()
    {
        return Port;
    }

    public boolean isLocal()
    {
        try
        {
            return Addr == InetAddress.getLocalHost();
        }
        catch(UnknownHostException ex)
        {
            return false;
        }
    }

    public boolean isOK()
    {
        return Addr != null;
    }

    public boolean equals(Object obj)
    {
        if(!(obj instanceof IpAddress))
            return false;
        IpAddress a = (IpAddress)obj;
        if(!a.getAddr().equals(Addr))
            return false;
        return a.getPort() == Port;
    }

    public int hashCode()
    {
        return Addr.hashCode() + Port;
    }

}
