package MonitorConfig;

import java.util.*;
import java.io.*;
import com.adventnet.snmp.snmp2.*;
import com.adventnet.snmp.mibs.*;
import java.io.Serializable;

class snmpRow extends Debug implements Serializable
{
    //numero di colonne
    int Ncolumns;
    //indice della riga (considero una numerazione da 1 a Ncolonne)
    String index;
    //vettore contenente gli elementi della riga
    Vector row;

    snmpRow(int ncol,String nriga,boolean deb,PrintStream o)
    {
        super(deb,o);
        row = new Vector();
        index = nriga;
        Ncolumns = ncol;
    }

    snmpRow(int ncol,String nriga,SnmpVar elements[],boolean deb,PrintStream o)
    {
        this(ncol,nriga,deb,o);
        if (elements.length < ncol)
        {
                trace_err("Ogni riga deve avere "+Ncolumns+" elementi");
                return;
        }
        for (int i=0; i<Ncolumns; i++)
            row.addElement(elements[i]);
        return;
    }

    snmpRow(int ncol,String nriga,SnmpPDU pdu_row,boolean deb, PrintStream o)
    {
        this(ncol,nriga,deb,o);

        Vector binds = pdu_row.getVariableBindings();
        if (binds.size() != ncol)
        {
            trace_err("Number of SnmpVar in PDU not sufficient");
            return;
        }
        int k=0;
        for (Enumeration e=binds.elements();e.hasMoreElements();)
            row.addElement(((SnmpVarBind)e.nextElement()).getVariable());
    }

    //permette di ottenere l'elemento di riga corrispondente ad una determinata colonna (da 1 a Ncolonne)
    //index e' l'indice di colonna
    //restituisce l'elemento di riga di tipo SnmpVar
    SnmpVar getElement(int index)
    {
        if (index <= Ncolumns)
            return ((SnmpVar)row.elementAt(--index));
        else
            return null;
    }

    //restituisce l'oid associato ad un elemento rispetto alla riga
    //col e' l'indice di colonna che individua l'elemento
    //es. se si tratta della riga 1 e della colonna 6 avro': 1.6
    String PartialOID(int col)
    {
        return(index+"."+col);
    }

    String rowIndex()
    {
        return(index);
    }

    void printRow(PrintStream o)
    {
        for(Enumeration e=row.elements();e.hasMoreElements();)
        {
            SnmpVar cur = (SnmpVar)e.nextElement();
            byte type = cur.getType();
            o.println(cur.toTagString());
        }
    }

    //indice da 1 a N
    void printElem(PrintStream o,int k,LeafSyntax leaf)
    {
        SnmpVar cur = (SnmpVar)row.elementAt(--k);
        byte type = cur.getType();
       /* if (type == SnmpAPI.NETWORKADDRESS)
            System.out.println("*NETWORKADDRESS");
        else if (type == SnmpAPI.BITSTRING)
            System.out.println("*BITSTRING");
        else if (type == SnmpAPI.IPADDRESS)
            System.out.println("*IPADDRESS");
        else if (type == SnmpAPI.NSAP)
            System.out.println("*NSAP");
        else if (type == SnmpAPI.OBJID)
            System.out.println("*OBJID");
        else if (type == SnmpAPI.TIMETICKS)
            System.out.println("*TIMETICKS");
        else if (type == SnmpAPI.NULLOBJ)
            System.out.println("*NULLOBJ");*/

        //N.B. non tutti gli interi hanno una label significativa associata
        if (type == SnmpAPI.INTEGER)
        {
            Integer val = (Integer) cur.toValue();
            String label = leaf.getLabel(val.intValue());
            if (label != null)
                o.println(cur.toTagString()+"("+label+")");
            else
                o.println(cur.toTagString());
        }
        else if ((leaf.toString()).equals("PhysAddress"))
        {
            SnmpString s = (SnmpString)cur;
            o.println(s.getTypeString()+":"+s.toByteString());
        }
        else    o.println(cur.toTagString());

    }


}