package StaticMonitoring;

import StaticMonitoring.Settings;
import MonitorConfig.snmpTable;
import com.adventnet.snmp.snmp2.*;
import java.io.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Hashtable;

//classe associata al polling: ripetizione ad intervalli regolari e per un certo intervallo
//di tempo di un'operazione Snmp semplice (get/getnext/getbulk) o derivata (getable\filtertable\hf\hftable)

public class Pollerb implements Operations
{
	sharedOut out;
    int observation;
    int interval ;
    int nvolte;
    SnmpSession req_session;
    Settings sets;
    String OIDs[];
    String argsop[];
    int req_op;
    MobileMonitoring.Alarm timer;
    StaticManager man_rif;
    //si usa un generico Vector per avere compatibilita' con vari tipi di risultati
    //GET/GETNEXT/GETBULK --> vettore di SnmpPDU
    //GETABLE/FILTERT --> vettore di snmpTable
    //HF ---> vettore di Object   HFTABLE ---> Hashtable
    Vector result;

    /**costruttore che,oltre agli argomenti normalmente necessari per l'esecuzione di un'operazione Snmp
    //elementare o derivata, deve conoscere l'intevallo di operativita' e l'intervallo di polling
    //man e' il manager Snmp che racchiude il codice associato alle varie operazioni
    //session e' la sessione gia' aperta e opportunamente settata
    //sets_in_request e' l'insieme dei settaggi associati alla richiesta
    //oids e' la lista degli oid oggetto di interesse
    //op e' il tipo di operazione che deve essere ripetuta
    //total e' l'intervallo di osservazione (in millisec)
    //gap e' l'intervallo di polling (in millisec)
    //o e' il PrintStream di output
    //deb e' lo stato di debugging
    */
    public Pollerb(StaticManager man,Settings Sets,SnmpSession session,String oids[],String extra[],int op,int total,int gap,sharedOut o)
    {
        out = o;
        observation = total;
        interval = gap;
        req_session = session;
        sets = Sets;
        man_rif = man;
        OIDs = oids;
        argsop = extra;
        req_op = op;
        nvolte = (total/gap);
        result = new Vector();
    }

    public Vector run()
    {
        timer = new MobileMonitoring.Alarm(interval);
        timer.start();
		for (int i=nvolte; --nvolte >= 0; )
		{
			doLocalJob();
			timer.await(MobileMonitoring.Alarm.FOREVER);
		}
		timer.stop();
		
		return result;
    }

    //viene eseguito ogni gap millisec --> contiene l'invocazione dell'operazione Snmp opportuna
    public void doLocalJob()
    {
    	new Thread()
    	{
    		public void run()
    		{
     		  //le successive righe sono eventualmente da togliere se si pensa di mandare i risultati
    		    //a qualcosa di diverso (es per graficare)

       			switch(req_op)
        		{
            		case GET:
                		SnmpPDU ris = man_rif.snmpOp(sets,req_session,OIDs,GET,null);
                		result.add(ris);
                		break;
            		case GETNEXT:
                		SnmpPDU ris1 = man_rif.snmpOp(sets,req_session,OIDs,GETNEXT,null);
                		result.add(ris1);
                		break;
            		case GETBULK:
                		SnmpPDU ris2 = man_rif.snmpOp(sets,req_session,OIDs,GETBULK,argsop);
                		result.add(ris2);
                		break;
           			case GETABLE:
                		snmpTable tab = man_rif.getTable(sets,req_session,OIDs[0]);
                		result.add(tab);
                		break;
            		case FILTERT:
              		  	String inf = argsop[0];
               		  	String cinf = argsop[1];
               		  	String col = argsop[2];
               		  	String csup = argsop[3];
                	  	String sup = argsop[4];
                		out.println("Matching Condition: "+inf+" "+cinf+" "+col+" "+csup+" "+sup);
                		snmpTable tabf = man_rif.FilterTable(sets,req_session,OIDs[0],inf,cinf,col,csup,sup);
                		result.add(tabf);
               			break;
                	case HF:
                		String hf = argsop[0];
                		Object val = man_rif.snmpHF(sets,req_session,hf);
                		result.add(val);
               			break;
                	case HFTABLE:
                		String hft = argsop[0];
                		Hashtable tabval = man_rif.snmpHFTable(sets,req_session,hft);
                		result.add(tabval);
               			break;
        		}

        	}
        }.start();

    }


}